# HC Inbox Authenctication Client

## Full signup form page..

Target Repo:[link](https://gitlab.com/Talking-DB/coding/pocs/ui-components/conversation-contact-details-panel/hc-inbox-authenctication-client/-/issues/11)

NODE JS version: 14.17.6

## About

Fixed issue #10.
Fixed issue #8.
Fixed issue #7.
Fixed issue #6.
Fixed issue #5.

## What

Fixed issue #4.
Create stories for Signup user details form component.

## About

Fixed issue #3.
Add Signup user details form component.
Signup forms are subscription boxes added to site, blog,app or social page to collect new subscribers.

## Usage

To access the content or services provided by the app a user has to create an account.

Frontend design of HC inbox signup page for desktop version.[onboarding for new user](https://www.figma.com/file/NGsJT7rZvB9KwcF5eqnAXS/HCI---Version-0.01?node-id=149%3A12561).

To integrate all the individual components of the form under one container.

[Storybook](https://6194b65ed498eb003ad6c0c0-catmpvrixu.chromatic.com/)

## Usage

Provides single platform to create an account for accessing the various services provided by the app.It also provides features description.
For testing the carousel component in isolate environments.

```
 npm install --save @fortawesome/react-fontawesome
 npm install --save @fortawesome/free-regular-svg-icons
```

Fixed issue #2.
Add boilerplate code as per contribution guidelines.
Boilerplate refers to sections of code that have to be included in many places with little or no alteration. It is often used when referring to languages that are considered verbose, i.e. the programmer must write a lot of code to do minimal jobs.

## Usage

To get a hands on experience with the creation of issue and merge request.

### To use Authscreen component as sign in and sign up

```
PropName :signup
propType: boolean
propValue: false for signin
           true for signup
```

### example:

1. For sign in
   ```
   <AuthScreen signup={false}/>
   ```
2. For sign up
   ```
   <AuthScreen signup={true}/>
   ```

## Installation

1. Install npm using the following command.

   ```
   npm install authentication-hci
   ```

   ```
   git clone git@gitlab.com:Talking-DB/coding/pocs/ui-components/conversation-contact-details-panel/hc-inbox-authenctication-client.git
   ```

2. Import.

```
import {AuthScreen} from 'authentication-hci';

function App() {
  return (
    <div>
      <AuthScreen />
    </div>
  );
}

```

```
npm install
```

3. Run the app in development mode.

   ```
   npm start
   ```

   Open http://localhost:3000 to view it in the browser.

4. Run the storybook using the following command
   ```
   npm run storybook
   ```
   Open http://localhost:6006 to view it in the browser.

## Dependencies

1. Install storybook using following command.

   ```
   npx sb init
   ```

2. Install ANT design using following command.
   ```
   npm install antd
   ```
3. Install React Fontawsome using the following command.

   ```
   npm install --save @fortawesome/react-fontawesome

   npm install --save @fortawesome/free-solid-svg-icons
   ```

4. Install React slick using following command.

   ```
   npm install react-slick --save
   ```

5. Install React Slick css using following command.
   ```
   npm install slick-carousel --save
   ```
6. Install react-responsive using following command

   ```
   npm install react-responsive --save
   ```

7. Insatll React router Dom version 6 using the following command
   ```
   npm install react-router-dom@6
   ```

![carouselSb](src/asset/carouselSb.PNG)
![carousel](demoImg/signinform.gif)
![socialmediasignupsection](demoImg/socialmediasignupsection.PNG)
![storybooksignup](src/asset/signupSbDesc.PNG)

## Component Output

![signupform](demoImg/signupformcomponent.PNG)
